/* cpuinfo_tt.h */

#ifndef CPUINFO_TT_H
#define CPUINFO_TT_H

#include <windows.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
  int EAX;
  int EBX;
  int ECX;
  int EDX;
} CPU_INFO;

typedef struct
{
  DWORD dwFamily;
  DWORD dwModel;
  DWORD dwStepping;
  DWORD dwBrandID;
  DWORD dwExtBrandID;
  char szVendorID[12 + 1];
  char szNameID[48 + 1];
} CPU_SIGNATURE;

void GetCpuVendorAndSignature(CPU_SIGNATURE * psig);

#define _CPU_FEATURE_MMX	    0x00000001
#define _CPU_FEATURE_MMXE	    0x00000002
#define _CPU_FEATURE_3DNow		0x00000004
#define _CPU_FEATURE_3DNowE	  0x00000008
#define _CPU_FEATURE_CMOV		  0x00000010
#define _CPU_FEATURE_SSE		  0x00000020
#define _CPU_FEATURE_SSE2		  0x00000040
#define _CPU_FEATURE_SSE3		  0x00000080
#define _CPU_FEATURE_SSSE3	  0x00000100
#define _CPU_FEATURE_SSE4_1	  0x00000200
#define _CPU_FEATURE_SSE4_2	  0x00000400
#define _CPU_FEATURE_SSE4A	  0x00000800
#define _CPU_FEATURE_SSE5     0x00001000
DWORD GetCpuFeature();

#define NON_TEMPORAL_STORES_NOT_SUPPORTED ((DWORD)-1)
DWORD GetNonTemporalDataSizeMin();


#ifdef __cplusplus
}
#endif

#endif /* CPUINFO_TT_H */